/*
 * genera N processi figli
 *
 * Commento: il padre genera N figli, ma siccome potrebbe finire prima
 * che finiscano i figli, allora l'output di ciascuno dei figli
 * potrebbe essere diverso, a seconda se fiiscono prima del padre o
 * viceversa.
 *
 * Esercizio: modificare il programma di modo che il padre finisca
 * SEMPRE prima dei figli.
 *  
 * SOLUZIONE: p2.c
 * 
 */
#include <stdio.h>

main(int argc, char *argv[])
{
  int i, N;
  int pid;

  if (argc < 2)
  {
    printf("USO: %s N\ngenera N processi figli\n\n", argv[0]);
    exit(0);
  }
  
  N = atoi(argv[1]);
  printf("padre %d genera %d figli\n", getpid(), N);
  
  for (i=0; i < N; i++)
  {
    if ((pid = fork()) < 0)
    {
      printf("Errore nella fork\n\n");
      exit(1);
    }
    if (pid == 0) /* il figlio */
    {
      printf("figlio %d del padre %d\n", getpid(), getppid());
      break;  /* esce dal ciclo */
    }
  }
}
