#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>

#define SERV_FIFO   "criptFIFO"

#define FILE_MODE (S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH)
#define MAXBUF_SIZE     1024
#define MAXNAME_LEN     100

#define CRIPT       1
#define DECRIPT     2

void sys_err(char *str)
{
  perror(str);
  exit(-1);
}

struct msg_req {
  int totlen;
  int type;
  int namelen;
  int strlen;
  char data[MAXBUF_SIZE];
};

inline void * getNamePos(void *ADDR) 
{
  return ADDR + 4 * sizeof(int);
}

inline void * getStrPos(void *ADDR) 
{
  return (getNamePos(ADDR) + ((struct msg_req *)ADDR)->namelen);
}

inline int getTotSize(void *ADDR) 
{
  return (4 * sizeof(int) + 
	  ((struct msg_req *)ADDR)->strlen + 
	  ((struct msg_req *)ADDR)->namelen );
}






