#include "criptserv.h"

int main()
{
  int end = 0;
  char c = 0;
  int len;
  char fifoname[MAXNAME_LEN];
  int fdes1, fdes2;
  struct msg_req request;
  char str[MAXBUF_SIZE - MAXNAME_LEN + 1];

  sprintf(fifoname,"clientFIFO%d", getpid());
  if (mkfifo(fifoname, FILE_MODE) < 0) 
    sys_err("Errore nella creazione della FIFO");

  while (!end) {

    while (c != 'c' && c != 'd' && c != 'q') { 
      printf("Vuoi criptare o decriptare? (c/d) (q per uscire)");
      c = getchar();
    }

    if (c == 'q') end = 1;
    else if (c == 'c') request.type = CRIPT;
    else if (c == 'd') request.type = DECRIPT;

    if (!end) {
      printf("Inserisci la stringa:");
      scanf("%s", str);

      c = getchar();
      c = 0;

      request.strlen = strlen(str);
      
      request.namelen = strlen(fifoname);
      
      memcpy(getNamePos(&request), fifoname, request.namelen);
      memcpy(getStrPos(&request), str, request.strlen);
      
      len = getTotSize(&request);
      request.totlen = len - sizeof(int);
      
      if ((fdes1 = open(SERV_FIFO, O_WRONLY)) < 0) 
	sys_err("error in opening the FIFO for writing");

      if (write(fdes1, &request, len) < 0)
	sys_err("error in writing to the FIFO");
      // seconda...
      if (write(fdes1, &request, len) < 0)
	sys_err("error in writing to the FIFO");

      if ((fdes2 = open(fifoname, O_RDONLY)) < 0)
	sys_err("error in opening the FIFO for reading");
      
      if (read(fdes2, &len, sizeof(int)) < 0)
	sys_err("error in reading from the FIFO");
      
      if (read(fdes2, str, len) < 0)
	sys_err("error in reading from the FIFO");

      str[len] = 0;

      close(fdes1);
      close(fdes2);
      printf("Il risultato e': %s\n", str);
    }

  }

  unlink(fifoname);

}
