#include "criptserv.h"

#define OFFSET 1

void cript (char *s, int t)
{
  int i = 0;

  while (s[i] != 0) {
    if (t == CRIPT) s[i] += OFFSET;
    else s[i] -= OFFSET;
    
    i++;
  }
}

int main()
{
  int n;
  FILE *f1, *f2;
  int fdes1, fdes2;
  int len;
  char fifoname[MAXNAME_LEN + 1];
  char str[MAXBUF_SIZE - MAXNAME_LEN + 1];
  
  struct msg_req request;

  if (mkfifo(SERV_FIFO, FILE_MODE) < 0) {
    if (errno != EEXIST) 
      sys_err("errore nella fifo");
  }

  if ((fdes1 = open(SERV_FIFO, O_RDONLY)) < 0)
    sys_err("error in opening the FIFO for reading");
  if (open(SERV_FIFO, O_WRONLY) < 0)
    sys_err("error in opening the FIFO for writing");

  for(;;) {
    printf("Waiting for a message...\n");
    if (read(fdes1, &request.totlen, sizeof(int)) < 0)
      sys_err("error in the read function!");
    if (request.totlen > (MAXBUF_SIZE + 3 * sizeof(int))) 
      printf("Message too long!\n");
    else {
      if ((n = read(fdes1, &request.type, request.totlen)) < 0)
	sys_err("error in the read function!");
      if (n != request.totlen)
	printf("Wrong size!\n");
      else if (request.namelen > MAXNAME_LEN) 
	printf("FIFO Name too long!\n");
      else if (request.strlen > (MAXBUF_SIZE - MAXNAME_LEN))
	printf("String too long!\n");
      else {
	memcpy(fifoname, getNamePos(&request), request.namelen);
	fifoname[request.namelen] = 0;
	
	if ((fdes2 = open(fifoname, O_WRONLY)) < 0)
	  printf("Error in opening the clientFIFO!!\n");
	else {
	  memcpy(str, getStrPos(&request), request.strlen);
	  str[request.strlen] = 0;
	  
	  cript(str, request.type);
	  
	  len = strlen(str);
	  
	  if (write(fdes2, &len, sizeof(int)) < 0)
	    printf("Error in writing to the client FIFO\n");
	  if (write(fdes2, str, len) < 0)
	    printf("Error in writing to the client FIFO\n");
	  
	  printf("Server: messaggio spedito!!\n");
	  
	  close(fdes2);
	}
      }
    }
  }
} 

