/* fork1.c */

#include <fcntl.h>
int	fdrd, fdwt;
char	c;

/* Due processi leggono da un file e scrivono su di un altro.
   Il file di output e' uguale a quello di input 
   ma con i caratteri mescolati a seconda della schedulazione */

main (int argc, char *argv[])
{  

  if (argc != 3) exit(1);
  if ((fdrd = open (argv[1], O_RDONLY)) == -1) 
    exit(1);
  if ((fdwt = creat(argv[2], 0666)) == -1)
    exit(1);
  fork();    /* Entrambe i processi eseguono lo stesso codice.
		Non c'e' controllo sulla corretta esecuzione di fork */
  rdwrt();
  exit(0);
}

int rdwrt (void)
{  
  int k;
  for (;;) { 
    if (read (fdrd, &c, 1) != 1) return;

    for (k=0; k < 10000; k++); // giusto per perdere tempo...

    write (fdwt, &c, 1);
  }
}
