#include "util.h"
#include <malloc.h>

int main(int argc, char *argv[])
{
  FILE *file;
  int i;
  double sum;
  double *v1,*v2;
  int n;

  if (argc < 3) {
    printf("Uso: %s n filename\n", argv[0]);
    printf("n        : numero di elementi dei vettore\n");
    printf("filename : file contenente i due vettori\n");
    exit(0);
  }

  n = atoi(argv[1]);
  
  if ((file = fopen(argv[2], "r")) == NULL) 
    sys_err("Non posso aprire il file");
  
  v1 = malloc(n * sizeof(double));
  v2 = malloc(n * sizeof(double));

  leggi_vettore(file, v1, n);
  leggi_vettore(file, v2, n);

  sum = 0;
  for(i = 0; i < n; i++)
    sum += v1[i] * v2[i];

  printf("il prodotto vettoriale e': %lf\n", sum);
}

