#include <sys/types.h>
#include <sys/stat.h>

int main(int argc, char *argv[])
{

  int i;
  struct stat buf;

  for (i = 1; i < argc; i++) {
    printf("%s:\n", argv[i]);
    if (lstat(argv[i], &buf) < 0) {
      perror("lstat error");
      continue;
    }
   
    printf("  access time   = %s", ctime(&(buf.st_atime)));
    printf("  mod. time     = %s", ctime(&(buf.st_mtime)));
    printf("  status change = %s", ctime(&(buf.st_ctime)));
  }

  exit(0);
}

