#include <sys/types.h>
#include <signal.h>
#include <stdio.h>

void timer_handler(int no)
{
  if (no != SIGALRM) {
    perror("Ricevuto il segnale sbagliato!");
    exit(-1);
  }
  return;
}

int main(void)
{
  int c;
  struct sigaction nuova, vecchia;

  nuova.sa_handler = timer_handler;
  sigemptyset(&nuova.sa_mask);
  nuova.sa_flags = 0;

  sigaction(SIGALRM,&nuova,&vecchia);

  alarm(5);
  printf("Premi un tasto seguti da <enter> prima di 5 secondi....");
  c = getchar();
  alarm(0);
  if (c < 0) 
    printf("l'allarme e' scattato!\n");
  else 
    printf("hai premuto un tasto prima dell'allarme\n");
  exit(0);
}

